SystemOrganization addCategory: #'Tp1-TADP'!
SystemOrganization addCategory: #'Tp1-TADP-Test'!

Trait named: #NoPoceado
	uses: {}
	category: 'Tp1-TADP'!

Trait named: #Poceado
	uses: {}
	category: 'Tp1-TADP'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:03'!
actualizarPozo
	self pozo:  (self apuestasEnJuego size * self valorDeJugada)! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:41'!
calculaAciertos: numeroDeAciertos paraJugada: jugadaGanadora
	^ self apuestasEnJuego select: [ :unaAp | (unaAp cuantosAciertosTieneEn: jugadaGanadora) = numeroDeAciertos ]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:48'!
pozo
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:01'!
valorDeJugada 
	self requirement! !

TestCase subclass: #Testeador
	instanceVariableNames: 'bruno quini6 apostaConMarta apuesta loto quini pagaLaPutaMadre prodeGanaRiver agenciaPirulo jugada sorteo bruna altaJugada nano unaJugada otraJugada teddy laAgenciaDeChola pancho quiniela losHijosDePuta milton changuin messiChino agenciaNoGanasNiEnPedo agenciaSeguiParticipando jugadaDos emoticonGuy kentucky prode frodo jugadaUno jugadaTres jugadaGanadora jugadaLooser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP-Test'!

!Testeador methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 23:03'!
testApuestaInicialLoto

	agenciaPirulo := Agencia new.
	loto := Loto new.
	bruno := Timbero new.
	jugada := OrderedCollection new.
	sorteo := Sorteo new.
	
	bruno initialize.
	loto initialize.
	agenciaPirulo initialize.
	
	jugada addAll: #(4 8 15 16 23 42).
	
	bruno armarApuestaDe: loto con: jugada para: agenciaPirulo con: 2.
	bruno jugar.
	
	sorteo sorteame: jugada alJuego: loto.
	self assert: agenciaPirulo caja equals: 0.28.
	self assert: bruno ganancia equals: 0.8.! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/8/2012 02:39'!
testApuestaInicialPagaOPaga

teddy := Timbero new.
laAgenciaDeChola := Agencia new.
pagaLaPutaMadre := PagaOPaga new.
sorteo := Sorteo new.
jugada := OrderedCollection new.
jugadaDos := OrderedCollection new.

teddy initialize.
laAgenciaDeChola initialize.
pagaLaPutaMadre initialize.
sorteo initialize.

jugada addAll: #(0 2 3 4 5 6 8 9 10 11 13 14 15 17 18).
jugadaDos addAll: #(99).

teddy armarApuestaDe: pagaLaPutaMadre con: jugada  para: laAgenciaDeChola con: 15.

teddy jugar.

"Aca no le pega a ningun numero"
sorteo sorteame: jugadaDos  alJuego: pagaLaPutaMadre.
self assert: laAgenciaDeChola caja equals: 0.

"Aca le pega a todos"
sorteo sorteame: jugada alJuego: pagaLaPutaMadre.
self assert: laAgenciaDeChola caja equals: 5.0625.
self assert: teddy ganancia equals: 35.4375
! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 05:38'!
testApuestaInicialProde

	pancho:= Timbero new. 
	frodo := Timbero new.
	messiChino := Timbero new.
	changuin := Timbero new.
	losHijosDePuta := Agencia new.
	prode := Prode new.
	jugadaLooser := OrderedCollection new.
	jugadaUno := OrderedCollection new.
	jugadaDos := OrderedCollection new.
	jugadaTres := OrderedCollection new.
	jugadaGanadora := OrderedCollection new.
	sorteo := Sorteo new.
	jugadaLooser addAll: #( e e e e e e e e e e e e e ).
	jugadaUno addAll: #( l v l v l v l v l v v l e).
	jugadaDos addAll: #( l v l v l v l v l v l e e).
	jugadaGanadora addAll: #( l v l v l v l v l v e e e).
	pancho initialize.
	frodo initialize.
	messiChino initialize.
	losHijosDePuta initialize.
	agenciaNoGanasNiEnPedo initialize.
	prode initialize.
	pancho 
		armarApuestaDe: prode 
		con: jugadaLooser 
		para: losHijosDePuta 
		con: 5.
	messiChino
		armarApuestaDe: prode 
		con: jugadaUno 
		para: losHijosDePuta 
		con: 5.
	frodo
		armarApuestaDe: prode 
		con:  jugadaDos 
		para: losHijosDePuta 
		con: 5.
	changuin
		armarApuestaDe: prode 
		con: jugadaGanadora 
		para: losHijosDePuta 
		con: 5.
	pancho jugar.
	frodo jugar.
	messiChino jugar.
	changuin jugar.
	sorteo sorteame: jugadaGanadora alJuego: prode.
	self assert: pancho ganancia equals: 0.
	self assert: messiChino ganancia equals: 2.2.
	self assert: frodo ganancia equals: 7.	
	self assert: changuin ganancia equals: 10.! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/7/2012 23:58'!
testApuestaInicialQuiniela

pancho := Timbero new.
losHijosDePuta := Agencia new.
quiniela := Quiniela new.
sorteo := Sorteo new.

pancho initialize.
losHijosDePuta initialize.
quiniela initialize.
pancho armarApuestaDe: quiniela con: '55' en: 10 para: losHijosDePuta con: 100.
pancho jugar.

"Aca no le pega a ningun numero"
sorteo sorteame: #(0000 2222 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333) alJuego: quiniela.
losHijosDePuta pagaALosGanadores.
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 0.


pancho initialize.
quiniela initialize.
losHijosDePuta initialize.
pancho armarApuestaDe: quiniela con: '0' en: 1 para: losHijosDePuta con: 100.
pancho jugar.

"Aca le pega a 1 cifra"
sorteo sorteame: #(0900 2222 3333 1010 4343 1212 8484 9999 1055 5455 3822 1463 7282 8254 7598 2512 8209 9412 6655 3333) alJuego: quiniela.
losHijosDePuta pagaALosGanadores.
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 700.




pancho initialize.
quiniela initialize.
losHijosDePuta initialize.
pancho armarApuestaDe: quiniela con: '55' en: 10 para: losHijosDePuta con: 100.
pancho jugar.

"Aca le pega a 2 cifras"
sorteo sorteame: #(0000 2222 3333 1010 4343 1212 8484 9999 1055 5455 3822 1463 7282 8254 7598 2512 8209 9412 6655 3333) alJuego: quiniela.
losHijosDePuta pagaALosGanadores .
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 7000.


pancho initialize.
quiniela initialize.
losHijosDePuta initialize.
pancho armarApuestaDe: quiniela con: '900' en: 1 para: losHijosDePuta con: 100.
pancho jugar.

"Aca le pega a 3 cifras"
sorteo sorteame: #(0900 2222 3333 1010 4343 1212 8484 9999 1055 5455 3822 1463 7282 8254 7598 2512 8209 9412 6655 3333) alJuego: quiniela.
losHijosDePuta pagaALosGanadores.
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 50000.


pancho initialize.
quiniela initialize.
losHijosDePuta initialize.
pancho armarApuestaDe: quiniela con: '9000' en: 1 para: losHijosDePuta con: 100.
pancho jugar.

"Aca le pega a 4 cifras"
sorteo sorteame: #(9000 2222 3333 1010 4343 1212 8484 9999 1055 5455 3822 1463 7282 8254 7598 2512 8209 9412 6655 3333) alJuego: quiniela.
losHijosDePuta pagaALosGanadores.
self assert: losHijosDePuta caja equals: 17.
self assert: pancho ganancia equals: 350000.
! !

!Testeador methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 02:14'!
testVariosGanadoresLoto
	milton := Timbero new.
	changuin := Timbero new.
	messiChino := Timbero new.
	agenciaNoGanasNiEnPedo := Agencia new.
	agenciaSeguiParticipando := Agencia new.
	loto := Loto new.
	jugada := OrderedCollection new.
	jugadaDos := OrderedCollection new.
	sorteo := Sorteo new.
	jugada addAll: #(4 8 15 16 23 42).
	jugadaDos addAll: #(4 8 15 16 23 40).
	milton initialize.
	messiChino initialize.
	changuin initialize.
	agenciaNoGanasNiEnPedo initialize.
	agenciaSeguiParticipando initialize.
	milton
		armarApuestaDe: loto
		con: jugada
		para: agenciaNoGanasNiEnPedo
		con: 2.
	messiChino
		armarApuestaDe: loto
		con: jugada
		para: agenciaNoGanasNiEnPedo
		con: 2.
	changuin
		armarApuestaDe: loto
		con: jugadaDos
		para: agenciaNoGanasNiEnPedo
		con: 2.
	milton jugar.
	messiChino jugar.
	changuin jugar.
	sorteo sorteame: jugada alJuego: loto.
	self assert: milton ganancia equals: 2 * 3 * 0.4 / 2.
	self assert: messiChino ganancia equals: 2 * 3 * 0.4 / 2.
	self assert: changuin ganancia equals: 2 * 3 * 0.17 / 1.
	self assert: agenciaNoGanasNiEnPedo caja equals: 0.8910000000000001.
	self assert: agenciaSeguiParticipando caja equals: 0! !

Object subclass: #Agencia
	instanceVariableNames: 'caja aPagar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:57'!
aPagar
	^ aPagar! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:04'!
aPagar: anObject
	aPagar add: anObject.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/8/2012 02:35'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 21:27'!
initialize 
	self caja: 0.
	aPagar := OrderedCollection new.! !

!Agencia methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 23:44'!
pagaALosGanadores
	self aPagar do: [:unaTupla | (unaTupla second) ganaste: (unaTupla first ) ]! !

!Agencia methodsFor: 'accessing' stamp: 'pdanibenitez 9/8/2012 04:07'!
pagale:jugador elMonto:pago

	| coleccionPago |
	coleccionPago := Array newFrom:(1 to: 2).
	coleccionPago at: 1 put: pago.
	coleccionPago at: 2 put: jugador.
	self aPagar: coleccionPago.
	
! !

Object subclass: #Apuesta
	instanceVariableNames: 'juego jugada agencia monto jugador posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia
	^ agencia! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia: anObject
	agencia := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:18'!
cuantosAciertosTieneEn: jugadaGanadora
	^ self jugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaEn: jugadaGanadora sumaUno: unNumero) ]! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 21:18'!
dameNumeroADividir: cantidadCifras
	cantidadCifras = 1 ifTrue: [^10].
		cantidadCifras = 2 ifTrue: [^100].
			cantidadCifras = 3 ifTrue: [^1000].
				cantidadCifras = 4 ifTrue: [^10000].! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego
	^ juego! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego: anObject
	juego := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada
	^ jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada: anObject
	jugada := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador
	^ jugador! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador: anObject
	jugador := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto: anObject
	monto := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 18:00'!
posicion
	^ posicion! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 18:00'!
posicion: anObject
	posicion := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:19'!
siEstaEn: unaJugada sumaUno: unNumero
	(unaJugada includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 23:19'!
sosGanadoraQuini: jugadaGanadora 
	| numeroGanadorEnPosicion cantidadCifras |
	numeroGanadorEnPosicion :=  jugadaGanadora asOrderedCollection at: self posicion.
	
	cantidadCifras := self jugada size.
	
	^(( numeroGanadorEnPosicion \\ (self dameNumeroADividir: cantidadCifras)) = ((self jugada) asNumber) ).
	
! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:10'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
recibiApuesta: apuesta
	self apuestasEnJuego add: apuesta! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/8/2012 03:10'!
repartirAAgencias
	apuestasEnJuego do: [ :apuest | apuest agencia ganaste: (apuest monto * self PorcentajeFijoPorJugada) ]! !

Juego subclass: #Loto
	uses: Poceado
	instanceVariableNames: 'pozo'
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgencia'
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Loto class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 21:21'!
PorcentajeFijoPorJugada
	^ 0.12! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 21:12'!
PorcentajeParaAgencia
	^ 0.05! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:05'!
calculaGanadoresYRepartiPremio: jugadaGanadora 
     | seisAsiertos cincoAsiertos cuatroAsiertos  |

	self actualizarPozo.	
	self repartirAAgencias.
	
	seisAsiertos := self calculaAciertos: 6 paraJugada: jugadaGanadora.	
	cincoAsiertos := self calculaAciertos: 5 paraJugada: jugadaGanadora.	
	cuatroAsiertos := self calculaAciertos: 4 paraJugada: jugadaGanadora.
	
	self pagarA: seisAsiertos conAciertos: 6.
	self pagarA: cincoAsiertos conAciertos: 5.
	self pagarA: cuatroAsiertos conAciertos: 4.



! !

!Loto methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 21:23'!
initialize 
	   super initialize.
	! !

!Loto methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 01:52'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta jugador 
				ganaste: 
					(self pozo * (apuesta juego porcentajePara: numeroDeAciertos) / apuestasGanadoras size)].
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste:
					(self pozo * (apuesta juego porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgencia ]! !

!Loto methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:34'!
porcentajePara: unNumero
	unNumero == 6 ifTrue: [^0.4].
	unNumero == 5 ifTrue: [^0.17].
	unNumero == 4 ifTrue: [^0.05].! !

!Loto methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:50'!
pozo
	^ pozo! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo: anObject
	pozo := anObject! !

!Loto methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:01'!
valorDeJugada
	^2! !

Juego subclass: #PagaOPaga
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeParaAgencia PorcentajeParaJugador'
	poolDictionaries: ''
	category: 'Tp1-TADP'!

PagaOPaga class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

!PagaOPaga class methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 23:58'!
porcentajeParaAgencia
	^ PorcentajeParaAgencia! !

!PagaOPaga class methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 23:58'!
porcentajeParaAgencia: anObject
	PorcentajeParaAgencia := anObject! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 23:59'!
PorcentajeParaAgencia
	^ 0.1! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 23:59'!
PorcentajeParaJugador 
	^ 0.7! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/8/2012 00:05'!
calculaGanadoresYRepartiPremio: jugadaGanadora 
	self apuestasEnJuego do: [:apuesta | self pagaleA: apuesta conJugada: jugadaGanadora ]! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 23:30'!
initialize 
	   super initialize.
	! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/8/2012 02:45'!
pagaleA: unaApuesta conJugada: jugadaGanadora
	unaApuesta jugador
		ganaste:
			(((unaApuesta cuantosAciertosTieneEn: jugadaGanadora) / 10) raisedTo: 3) * unaApuesta monto * self PorcentajeParaJugador.
	unaApuesta agencia
		ganaste:
			(((unaApuesta cuantosAciertosTieneEn: jugadaGanadora) / 10) raisedTo: 3) * unaApuesta monto * self PorcentajeParaAgencia.! !

Juego subclass: #Prode
	uses: Poceado
	instanceVariableNames: 'pozo'
	classVariableNames: 'PorcentajeFijoPorJugada'
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Prode class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:27'!
PorcentajeFijoPorJugada 
	^ 0.15! !

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:40'!
calculaGanadoresYRepartiPremio: jugadaGanadora
	| primerPremio segundoPremio tercerPremio |
	self actualizarPozo.
	self repartirAAgencias.
	
	primerPremio := self calculaAciertos: 13 paraJugada: jugadaGanadora.
	segundoPremio := self calculaAciertos: 12 paraJugada: jugadaGanadora.
	tercerPremio := self calculaAciertos: 11 paraJugada: jugadaGanadora.
	
	self pagarA: primerPremio  conAciertos: 13.
	self pagarA: segundoPremio  conAciertos: 12.
	self pagarA: tercerPremio  conAciertos: 11.
! !

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:19'!
pozo
	^ pozo! !

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 03:18'!
pozo: anObject
	pozo := anObject.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:01'!
valorDeJugada
	^5! !

Juego subclass: #Quiniela
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada'
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Quiniela class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/8/2012 03:11'!
PorcentajeFijoPorJugada 
	^ 0.17! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:11'!
calculaGanadoresYRepartiPremio: jugadaGanadora
	| coleccionDeGanadores |
	
	self repartirAAgencias.
	
	coleccionDeGanadores := apuestasEnJuego select: [ :ap | ap sosGanadoraQuini: jugadaGanadora ].
	coleccionDeGanadores do: [ :apuestaG | apuestaG agencia pagale: apuestaG jugador elMonto: (self correspondePagar: apuestaG) ]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:10'!
correspondePagar: apuestaG 

	| tipoDeGanancia |
	apuestaG jugada size = 1 ifTrue: [tipoDeGanancia := 7].
		apuestaG jugada size = 2 ifTrue: [tipoDeGanancia := 70].
			apuestaG jugada size = 3 ifTrue: [tipoDeGanancia := 500].
				apuestaG jugada size = 4 ifTrue: [tipoDeGanancia := 3500].
		
	^apuestaG monto * tipoDeGanancia ! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'pdanibenitez 9/8/2012 04:10'!
initialize 
	super initialize.! !

Object subclass: #Sorteo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Sorteo methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:12'!
sorteame: jugadaGanadora alJuego: juego
	juego calculaGanadoresYRepartiPremio: jugadaGanadora! !

Object subclass: #Timbero
	instanceVariableNames: 'apuestas ganancia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:01'!
apuestas
	^ apuestas! !

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 18:02'!
armarApuestaDe: unJuego con: unaJugada en: unaPosicion para: unaAgencia con: unMonto
	| unaApuesta |
	
	unaApuesta := Apuesta new.
	unaApuesta juego: unJuego.
	unaApuesta jugada: unaJugada.
	unaApuesta posicion: unaPosicion.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unMonto.
	unaApuesta jugador: self.
	
	self apuestas add: unaApuesta.
	
	! !

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/7/2012 18:01'!
armarApuestaDe: unJuego con: unaJugada para: unaAgencia con: unMonto
	| unaApuesta |
	
	unaApuesta := Apuesta new.
	unaApuesta juego: unJuego.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unMonto.
	unaApuesta jugador: self.
	
	self apuestas add: unaApuesta.
	
	! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 23:23'!
ganancia
	^ ganancia! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:49'!
ganancia: unNumero
	ganancia := unNumero! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/7/2012 22:32'!
ganaste: unaCantidad
	self ganancia: (self ganancia + unaCantidad)  ! !

!Timbero methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/7/2012 22:47'!
initialize 
	super initialize. 
	apuestas := OrderedCollection new.
	self ganancia: 0.


	! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/6/2012 17:44'!
jugar
	self apuestas do:[ :apuesta | apuesta juego recibiApuesta: apuesta ].! !
